"""
    BIMData API

    BIMData API is a tool to interact with your models stored on BIMData’s servers.     Through the API, you can manage your projects, the clouds, upload your IFC files and manage them through endpoints.  # noqa: E501

    The version of the OpenAPI document: v1 (v1)
    Contact: support@bimdata.io
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from bimdata_api_client.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from bimdata_api_client.exceptions import ApiAttributeError



class IfcExportRequest(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('classifications',): {
            'ORIGINAL': "ORIGINAL",
            'UPDATED': "UPDATED",
            'NONE': "NONE",
        },
        ('zones',): {
            'ORIGINAL': "ORIGINAL",
            'UPDATED': "UPDATED",
            'NONE': "NONE",
        },
        ('properties',): {
            'ORIGINAL': "ORIGINAL",
            'UPDATED': "UPDATED",
            'NONE': "NONE",
        },
        ('systems',): {
            'ORIGINAL': "ORIGINAL",
            'UPDATED': "UPDATED",
            'NONE': "NONE",
        },
        ('layers',): {
            'ORIGINAL': "ORIGINAL",
            'UPDATED': "UPDATED",
            'NONE': "NONE",
        },
        ('materials',): {
            'ORIGINAL': "ORIGINAL",
            'UPDATED': "UPDATED",
            'NONE': "NONE",
        },
        ('attributes',): {
            'ORIGINAL': "ORIGINAL",
            'UPDATED': "UPDATED",
            'NONE': "NONE",
        },
        ('structure',): {
            'ORIGINAL': "ORIGINAL",
            'UPDATED': "UPDATED",
            'NONE': "NONE",
        },
    }

    validations = {
        ('file_name',): {
            'max_length': 512,
            'min_length': 1,
        },
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'file_name': (str,),  # noqa: E501
            'classifications': (str,),  # noqa: E501
            'zones': (str,),  # noqa: E501
            'properties': (str,),  # noqa: E501
            'systems': (str,),  # noqa: E501
            'layers': (str,),  # noqa: E501
            'materials': (str,),  # noqa: E501
            'attributes': (str,),  # noqa: E501
            'structure': (str,),  # noqa: E501
            'uuids': ([str],),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'file_name': 'file_name',  # noqa: E501
        'classifications': 'classifications',  # noqa: E501
        'zones': 'zones',  # noqa: E501
        'properties': 'properties',  # noqa: E501
        'systems': 'systems',  # noqa: E501
        'layers': 'layers',  # noqa: E501
        'materials': 'materials',  # noqa: E501
        'attributes': 'attributes',  # noqa: E501
        'structure': 'structure',  # noqa: E501
        'uuids': 'uuids',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, file_name, *args, **kwargs):  # noqa: E501
        """IfcExportRequest - a model defined in OpenAPI

        Args:
            file_name (str): The name of the exported IFC file. It MUST end with .ifc or the exported file won't be processed by BIMData

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            classifications (str): Exported IFC will include classifications from original IFC file (ORIGINAL), from latest API updates (UPDATED), or won't include classifications(NONE)  * `ORIGINAL` - ORIGINAL * `UPDATED` - UPDATED * `NONE` - NONE. [optional] if omitted the server will use the default value of "UPDATED"  # noqa: E501
            zones (str): Exported IFC will include zones from original IFC file (ORIGINAL), from latest API updates (UPDATED), or won't include zones(NONE)  * `ORIGINAL` - ORIGINAL * `UPDATED` - UPDATED * `NONE` - NONE. [optional] if omitted the server will use the default value of "UPDATED"  # noqa: E501
            properties (str): Exported IFC will include properties from original IFC file (ORIGINAL), from latest API updates (UPDATED), or won't include properties(NONE)  * `ORIGINAL` - ORIGINAL * `UPDATED` - UPDATED * `NONE` - NONE. [optional] if omitted the server will use the default value of "UPDATED"  # noqa: E501
            systems (str): Exported IFC will include systems from original IFC file (ORIGINAL), from latest API updates (UPDATED), or won't include systems(NONE)  * `ORIGINAL` - ORIGINAL * `UPDATED` - UPDATED * `NONE` - NONE. [optional] if omitted the server will use the default value of "UPDATED"  # noqa: E501
            layers (str): Exported IFC will include layers from original IFC file (ORIGINAL), from latest API updates (UPDATED), or won't include layers(NONE)  * `ORIGINAL` - ORIGINAL * `UPDATED` - UPDATED * `NONE` - NONE. [optional] if omitted the server will use the default value of "UPDATED"  # noqa: E501
            materials (str): Exported IFC will include materials from original IFC file (ORIGINAL), from latest API updates (UPDATED), or won't include materials(NONE)  * `ORIGINAL` - ORIGINAL * `UPDATED` - UPDATED * `NONE` - NONE. [optional] if omitted the server will use the default value of "UPDATED"  # noqa: E501
            attributes (str): Exported IFC will include attributes from original IFC file (ORIGINAL), from latest API updates (UPDATED), or won't include attributes(NONE)  * `ORIGINAL` - ORIGINAL * `UPDATED` - UPDATED * `NONE` - NONE. [optional] if omitted the server will use the default value of "UPDATED"  # noqa: E501
            structure (str): Exported IFC will include the structure from original IFC file (ORIGINAL), from latest API updates (UPDATED), or won't include structure(NONE)  * `ORIGINAL` - ORIGINAL * `UPDATED` - UPDATED * `NONE` - NONE. [optional] if omitted the server will use the default value of "UPDATED"  # noqa: E501
            uuids ([str]): Exported IFC will only have those elements. If omitted, all elements will be exported. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.file_name = file_name
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, file_name, *args, **kwargs):  # noqa: E501
        """IfcExportRequest - a model defined in OpenAPI

        Args:
            file_name (str): The name of the exported IFC file. It MUST end with .ifc or the exported file won't be processed by BIMData

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            classifications (str): Exported IFC will include classifications from original IFC file (ORIGINAL), from latest API updates (UPDATED), or won't include classifications(NONE)  * `ORIGINAL` - ORIGINAL * `UPDATED` - UPDATED * `NONE` - NONE. [optional] if omitted the server will use the default value of "UPDATED"  # noqa: E501
            zones (str): Exported IFC will include zones from original IFC file (ORIGINAL), from latest API updates (UPDATED), or won't include zones(NONE)  * `ORIGINAL` - ORIGINAL * `UPDATED` - UPDATED * `NONE` - NONE. [optional] if omitted the server will use the default value of "UPDATED"  # noqa: E501
            properties (str): Exported IFC will include properties from original IFC file (ORIGINAL), from latest API updates (UPDATED), or won't include properties(NONE)  * `ORIGINAL` - ORIGINAL * `UPDATED` - UPDATED * `NONE` - NONE. [optional] if omitted the server will use the default value of "UPDATED"  # noqa: E501
            systems (str): Exported IFC will include systems from original IFC file (ORIGINAL), from latest API updates (UPDATED), or won't include systems(NONE)  * `ORIGINAL` - ORIGINAL * `UPDATED` - UPDATED * `NONE` - NONE. [optional] if omitted the server will use the default value of "UPDATED"  # noqa: E501
            layers (str): Exported IFC will include layers from original IFC file (ORIGINAL), from latest API updates (UPDATED), or won't include layers(NONE)  * `ORIGINAL` - ORIGINAL * `UPDATED` - UPDATED * `NONE` - NONE. [optional] if omitted the server will use the default value of "UPDATED"  # noqa: E501
            materials (str): Exported IFC will include materials from original IFC file (ORIGINAL), from latest API updates (UPDATED), or won't include materials(NONE)  * `ORIGINAL` - ORIGINAL * `UPDATED` - UPDATED * `NONE` - NONE. [optional] if omitted the server will use the default value of "UPDATED"  # noqa: E501
            attributes (str): Exported IFC will include attributes from original IFC file (ORIGINAL), from latest API updates (UPDATED), or won't include attributes(NONE)  * `ORIGINAL` - ORIGINAL * `UPDATED` - UPDATED * `NONE` - NONE. [optional] if omitted the server will use the default value of "UPDATED"  # noqa: E501
            structure (str): Exported IFC will include the structure from original IFC file (ORIGINAL), from latest API updates (UPDATED), or won't include structure(NONE)  * `ORIGINAL` - ORIGINAL * `UPDATED` - UPDATED * `NONE` - NONE. [optional] if omitted the server will use the default value of "UPDATED"  # noqa: E501
            uuids ([str]): Exported IFC will only have those elements. If omitted, all elements will be exported. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.file_name = file_name
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
